<?php
/**
* Plugin WDDWebLinks
*
* @package	PLX
* @version	1.1
* @date	16/09/22
* @author Bronco
**/
class WDDWebLinks extends plxPlugin {

	private $cats; #string
	private $title; #string
	private $linkname; #string
	private $catId; #string
	private $plxMotor,$plxAdmin,$plxPlugins,$plxShow;
 
	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);		
		
		# limite l'acces a l'ecran de configuration du plugin
		# PROFIL_ADMIN , PROFIL_MANAGER , PROFIL_MODERATOR , PROFIL_EDITOR , PROFIL_WRITER
		$this->setConfigProfil(PROFIL_ADMIN);
		
		
		# Declaration d'un hook (existant ou nouveau)
		$this->addHook('IndexBegin','IndexBegin');
		$this->addHook('AdminIndexPrepend','AdminIndexPrepend');
		$this->addHook('AdminPrepend','AdminPrepend');
		$this->addHook('AdminArticlePrepend','AdminArticlePrepend');
		$this->addHook('AdminArticleFoot','AdminArticleFoot');
		//$this->addHook('AdminArticleTop','AdminArticleTop');
		$this->addHook('plxAdminEditArticle','plxAdminEditArticle');
		$this->addHook('plxAdminEditArticleXml','plxAdminEditArticleXml');
		$this->addHook('AdminArticleContent','AdminArticleContent');
		$this->addHook('AdminProfilTop','AdminProfilTop');
		$this->addHook('AdminArticlePreview','AdminArticlePreview');
		$this->addHook('AdminArticleParseData','AdminArticleParseData');
		$this->addHook('AdminArticlePostData','AdminArticlePostData');
		$this->addHook('AdminArticleInitData','AdminArticleInitData');
		$this->addHook('plxShowLastArtListContent','plxShowLastArtListContent');
		$this->addHook('plxMotorParseArticle','plxMotorParseArticle');
		$this->addHook('showBookmarkletLink','showBookmarkletLink');
		$this->addHook('getTagList','getTagList');
		$this->addHook('showLinksPageLink','showLinksPageLink');
		$this->addHook('showLinkedURL','showLinkedURL');
		$this->addHook('showPermalink','showPermalink');
		$this->addHook('showWebLinksRSSLink','showWebLinksRSSLink');
		$this->addHook('plxFeedRssArticlesXml','plxFeedRssArticlesXml');
		$this->title=$this->getParam("Titre");
		$this->linkname=$this->getParam("linkname");
		if (empty($this->linkname)){
			$this->setParam("linkname", '♻ Post a link', "string");
		}
		
		
	}
	# Activation / desactivation
	public function OnActivate() {
		
		$cats=$this->plxAdmin->aCats;
		$cats2=array();
		$max=0;
		foreach ($cats as $id => $data) {
			$cats2[$data['name']]=$data;
			$max=max($max,intval($id));
		}
		
		if (empty($this->title)){
			$this->title="WebLinks";
			$this-> setParam("Titre", "WebLinks", "string");
		}
		if (empty($cats2[$this->title])){
			$max++;
			$max="$max";
			$max=str_repeat('0', 3-strlen($max)).$max;
			$newcat='<categorie number="'.$max.'" active="1" tri="desc" bypage="5" menu="non" url="'.plxUtils::title2url($this->title).'" template="categorie.php"><name><![CDATA['.$this->title.'!]]></name><description><![CDATA[Trouvé sur le net]]></description><meta_description><![CDATA[Trouvé sur le net]]></meta_description><meta_keywords><![CDATA[liens internet veille]]></meta_keywords><title_htmltag><![CDATA['.$this->title.']]></title_htmltag></categorie>';
			$categories=file_get_contents('../../'.PLX_CONFIG_PATH.'categories.xml');
			$categories=str_replace('</document>',$newcat.'</document>',$categories);
			file_put_contents('../../'.PLX_CONFIG_PATH.'categories.xml', $categories);
			
		}
	
	}
	public function OnDeactivate() {
		# code à executer à la désactivation du plugin
	}
	

	########################################
	# HOOKS
	########################################





	########################################
	# IndexBegin
	########################################
	# Description:
	public function IndexBegin(){
		$this->setPlxVars();		
		$this->setCatId();
		if (empty($_SESSION['user'])){ # pas connecté
			$pw_input    ='<label>Mot de passe</label><input type="password" name="password"/>';
			$action      =PLX_CORE.'admin/auth.php';
		}else{ # connecté
			$pw_input    ='';
			$action      =PLX_CORE.'admin/article.php';
			
		}

		#gestion de la génération du formulaire si on vient du bookmarklet
		if (!empty($_GET['source'])&&$_GET['source']=='bookmarkletweblinks'){
			$artId                         = $this->newIdArticle();
			$token                         = sha1(mt_rand(0, 1000000));
			$_SESSION['formtoken'][$token] = time();
			$token                         ='<input name="token" value="'.$token.'" type="hidden" />';				
			$login                         = $this->plxMotor->aUsers[strip_tags($_GET['user'])]['login'];
			$url                           =strip_tags($_GET['url']);
			$from                          =!empty($_GET['from'])?strip_tags($_GET['from']):'';
			$titres_path 				   =PLX_ROOT.'data/medias/images/titres/';
			if (is_dir($titres_path)){
				$titles=glob($titres_path.'*');
				$select='<div>Ou choisir une image <select id="HeaderTitlePic" style="width:100%;margin-bottom:25px" name="image_title"><option value=""></option>';
				foreach ($titles as $file) {
					if (strpos($file,'_THUMB_')!==false){continue;}
					$file=str_replace(PLX_ROOT,'',$file);
					$select.= '<option value="'.$file.'">'.basename($file).'</option>';
				}
				$select.='</select></div>';
			}else{$select='';}
			
			if (preg_match('#youtube\.com\/watch\?v=(?<youtube_id>[a-zA-Z0-9_]+)#', $url,$result)){
				$youtube_thumb_url='https://img.youtube.com/vi/'.$result['youtube_id'].'/maxresdefault.jpg';
			}else{
				$youtube_thumb_url='';
			}

			$media_link					   ="
			var title = 'medias';window.open('".PLX_CORE."admin/medias.php','','menubar=no,height=' + screen.height +',width=' + screen.width+',toolbar=no,scrollbars=auto,status=no,top=0,left=0');
			";
			

			echo '<html><head><title>Poster un lien sur le site</title><meta http-equiv="Content-Type" content="text/html; charset=utf-8" />';
			echo '
			
			<link rel="stylesheet" href="./'.$this->plxShow->plxMotor->aConf['racine_themes'].$this->plxShow->plxMotor->style.'/css/theme.css"/>
			<link rel="stylesheet" href="./'.$this->plxShow->plxMotor->aConf['racine_themes'].$this->plxShow->plxMotor->style.'/css/admin.css"/>
			<link rel="stylesheet" href="./'.$this->plxShow->plxMotor->aConf['racine_themes'].$this->plxShow->plxMotor->style.'/css/plucss.css"/>
			<link rel="stylesheet" href="'.PLX_PLUGINS.'WDDWebLinks/style.css"/>

			</head><body><div class="container weblinks">';
			echo '
				<h1> Poster un lien sur le site </h1>
				<form action="'.$action.'" method="post" enctype="multipart/form-data" >
					'.$token.'
					<input type="hidden" name="source" value="bookmarkletweblinks"/>
					<input type="hidden" name="login" value="'. $login.'"/>
					<input type="hidden" name="author" value="'.$_GET['user'].'"/>

					<input type="hidden" name="date_publication_day" value="'.date('d').'"/>
					<input type="hidden" name="date_publication_day" value="'.date('d').'"/>
					<input type="hidden" name="date_creation_day" value="'.date('d').'"/>
					<input type="hidden" name="date_update_day" value="'.date('d').'"/>

					<input type="hidden" name="date_publication_month" value="'.date('m').'"/>
					<input type="hidden" name="date_creation_month" value="'.date('m').'"/>
					<input type="hidden" name="date_update_month" value="'.date('m').'"/>

					<input type="hidden" name="date_publication_year" value="'.date('Y').'"/>
					<input type="hidden" name="date_creation_year" value="'.date('Y').'"/>
					<input type="hidden" name="date_update_year" value="'.date('Y').'"/>

					<input type="hidden" name="date_publication_time" value="'.date('H:i').'"/>
					<input type="hidden" name="date_creation_time" value="'.date('H:i').'"/>
					<input type="hidden" name="date_update_time" value="'.date('H:i').'"/>

					<input type="hidden" name="new_catname" value=""/>
					<input type="hidden" name="title_htmltag" value=""/>
					<input type="hidden" name="meta_description" value=""/>
					<input type="hidden" name="meta_keywords" value=""/>
					<input type="hidden" name="artId" value="'.$this->newIdArticle().'"/>
					<input type="hidden" name="catId[]" value="'.$this->catId.'"/>
					<input type="hidden" name="thumbnail_title" value=""/>
					<input type="hidden" name="thumbnail_alt" value="image titre"/>
					<input type="hidden" name="url" value=""/>
					
					<input type="hidden" name="chapo" value=""/>
					<input type="hidden" name="template" value="article.php"/>';
					
					echo $pw_input;

					echo '
					<label>URL de la page d\'origine</label>
					<input type="url" name="url_link" value="'.strip_tags($_GET['url']).'"/>
					<label>Titre</label>
					<input type="text" name="title" value="'.str_replace('__',' ',strip_tags($_GET['title'])).'" placeholder="Titre du post"/>
					<label>Via</label>
					<input type="text" name="via" value="'.$from.'" placeholder="Source du lien"/>
					<label>Image</label>
					Uploader une image
					<input type="file" name="thumbnail" value="" placeholder="image d\'illustration: http://www.domain.fr/image.png"  accept="image/*"/>
					'.$select.'
					Ou taper l\'url d\'une image
					<input type="url" name="image" value="'.$youtube_thumb_url.'" list="tags_list" placeholder="http://image.com/a/recuperer"/>	


					<label>Contenu du post</label>';
					eval($this->plxShow->callHook("markdownBar","#id_content"));
					echo'
					 	<textarea id="id_content" name="content" placeholder="Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."></textarea>
					 	<small>pour insérer des vidéos/des liens/des images, il suffit de coller leur adresse</small>
					<label>Tags</label>
						
					 	<div id="tags_list">'.$this->getTagList().'</div>
					 	<input type="text" name="tags[]" value="" list="tags_list" placeholder="nouveau tag1,nouveau tag2..."/>
					 
					<label><input type="checkbox" name="allow_com" value="1" checked/> Commentaires</label>

					 <div class="save-fixed">
					 	<input type="button" onclick="'.$media_link.';return false;" value="&#9712; Medias"/>
					 	<input type="submit" name="publish" value="☀ Publier (public)"/>
					 	<input type="submit" name="draft"   value="✋ Brouillon (privé)"/>
					 </div><div class="emotes_list">';
					
					
					eval($this->plxShow->callHook("WDD_replace_list","active_emotes"));
					eval($this->plxShow->callHook("WDD_replace_js"));
					eval($this->plxShow->callHook("markdownJs"));
					eval($this->plxShow->callHook("markdownAssets"));
				echo '</div></form>
				</div></body></html>
			';
			exit();
		}
		
	}

	########################################
	# AdminPrepend
	########################################
	# Description:
	public function AdminPrepend(){
		
		echo '<?php
		
		if (!empty($_POST["source"])&&empty($_SESSION["post"])){ 			
			$_SESSION["post"]=$_POST;
			if (!empty($_FILES["thumbnail"])){
				$_SESSION["files"]=$_FILES;
			}			
		}
		
		?>';
	}
	########################################
	# AdminIndexPrepend
	########################################
	# Description:
	public function AdminIndexPrepend(){
		# redirige vers article.php après une connexion via le bookmarklet
		echo '<?php 
		if (!empty($_SESSION["post"])||!empty($_POST["source"])){ 			
			header("location: '.PLX_CORE.'admin/article.php");
		}
		
		?>';
	}

	########################################
	# AdminArticlePrepend
	########################################
	public function AdminArticlePrepend(){

		if (empty($_POST['source']) && !empty($_SESSION['post'])){
			$_POST=$_SESSION['post'];
		}
		if (empty($_FILES['thumbnail']) && !empty($_SESSION['files'])){
			$_FILES['thumbnail']=$_SESSION['files'];
		}

		# on vient de poster via le bookmarklet ?
		if (!empty($_POST['source'])&&$_POST['source']=='bookmarkletweblinks'){		
			$_POST['tags']=trim(implode(',',$_POST['tags']),',');
			# Si on a posté une image d'illustration, on gère l'upload
			if (!empty($_FILES['thumbnail']["name"])&&empty($_FILES['error'])){
				$dest_path=PLX_ROOT.'data/medias/images/_WEBLINKS';
				if (!is_dir($dest_path)){mkdir($dest_path);}
				$tmp=$_FILES['thumbnail']['tmp_name'];
				$fil=explode('?',strip_tags(basename($_FILES['thumbnail']['name'])));
				$fil=$fil[0];
				$fil=plxUtils::title2url(strip_tags($_POST['title'])).'-'.$fil;
				$loc=$dest_path.'/'.$fil;

				if (stripos($_FILES['thumbnail']['type'],'image/')!==false){
					rename ($tmp,$loc);
					chmod($loc,0644);
					$_FILES['thumbnail']['name']=$loc;
				}else{$_FILES['thumbnail']['name']="";}
			}
			
			$_POST['url']=plxUtils::title2url($_POST['url']).uniqid();
			//$_POST['content']=nl2br($_POST['content']);
			if (!empty($_POST['via'])){
				$_POST['via']=strip_tags($_POST['via']);
				$_POST['content'].='<div class="via"><span title="Source du lien">Via '.$_POST['via'].'</span></div>';
			}
			# gestion des données du formulaire
			if (!empty($_FILES['thumbnail']["name"])){
				echo '<?php $_POST["thumbnail"]="'.$_FILES['thumbnail']["name"].'";?>';
			}elseif (!empty(trim($_POST['image']))){
				# si on a fourni l'url d'une image, on la récupère en local
				$_POST['image']=strip_tags($_POST['image']);
				$dest_path=PLX_ROOT.'data/medias/images/_WEBLINKS';
				$fil=explode('?',basename($_POST['image']));
				$fil=$fil[0];
				$fil=plxUtils::title2url(strip_tags($_POST['title'])).'-'.$fil;
				$loc=$dest_path.'/'.$fil;
				$image=file_get_contents($_POST['image']);
				$_POST['content'].='<br/><br/><div class="img_source"><a href="'.$_POST['image'].'">Source image</a></div>';
				if ($image){
					file_put_contents($loc,$image);
					chmod($loc,0644);
					echo '<?php $_POST["thumbnail"]="data/medias/images/_WEBLINKS/'.$fil.'"; ?>';
				}else{
					echo '<?php $_POST["thumbnail"]="'.PLX_PLUGINS.'/WDDWebLinks/default_image.jpg"; ?>';
				}
			}elseif(!empty($_POST['image_title'])){
				echo '<?php $_POST["thumbnail"]="'.strip_tags($_POST['image_title']).'"; ?>';
			}
			echo '
			<?php if(!empty($_POST) && !isset($_POST["url_link"])) {$_POST["url_link"]="";}	?>
			';

			unset($_SESSION["post"]);
			if (!isset($_POST['draft'])){$_SESSION['close_bookmarklet']=true;}
			unset($_FILES);
		}
		
	}

	##############################################################################
	# AdminArticleFoot
	##############################################################################
	# ferme le bookmarklet
	public function AdminArticleFoot(){
		if (!empty($_SESSION['close_bookmarklet'])){
			unset($_SESSION['close_bookmarklet']);
			echo '<script>window.close();</script>';
		}
	}

	##############################################################################
	# plxFeedRssArticlesXml
	##############################################################################
	# transforme le flux rss pour intégrer l'url associée à l'article et ajouter le permalink
	public function plxFeedRssArticlesXml(){
		echo '<?php
				$thumb="'.PLX_PLUGINS.'/WDDWebLinks/default_image.jpg"; 
				$entries=explode("<item>",$entry);
				if (!empty($entries)){
					unset($entries[count($entries)-1]);
					$entry=implode("<item>",$entries);
				}
				if ($this->plxRecord_arts->f("thumbnail")!=""){$thumb=\'<img src="\'.$this->urlRewrite($this->plxRecord_arts->f("thumbnail")).\'" style="width:100%;height:auto"/>\';}

				if (empty($oldArtId)||$oldArtId!=$artId){
					$oldArtId=$artId;
					$entry .= "\t<item>\n";
					$entry .= "\t\t"."<title>".plxUtils::strCheck($this->plxRecord_arts->f("title"))."</title> "."\n";
					if ($this->plxRecord_arts->f("url_link")!=""){
						$entry .= "\t\t"."<link>".htmlspecialchars($this->plxRecord_arts->f("url_link"))."</link>"."\n";
					}
					$entry .= "\t\t"."<guid>".$this->urlRewrite("?article".$artId."/".$this->plxRecord_arts->f("url"))."</guid>"."\n";
					$entry .= "\t\t"."<description><![CDATA[".$thumb.plxUtils::rel2abs($this->racine,$content)."<br/><hr/><a href=\"".$this->urlRewrite("?article".$artId."/".$this->plxRecord_arts->f("url")."#comments")."\" title=\"commenter ou voir les commentaires sur ce lien\"><small>&#9658; Commentaires</small></a>]]></description>\n";
					$entry .= "\t\t"."<pubDate>".plxDate::dateIso2rfc822($this->plxRecord_arts->f("date"))."</pubDate>"."\n";
					$entry .= "\t\t"."<dc:creator>".plxUtils::strCheck($author)."</dc:creator>"."\n";
				}
				?>';
	}

	##############################################################################
	# plxAdminEditArticleXml
	##############################################################################
	# Ajoute le stockage de l'adresse du lien dans le fichier de l'article
	public function plxAdminEditArticleXml(){
		echo '<?php 
					$url_link = plxUtils::getValue($content["url_link"]);
					$xml .= "\t<url_link><![CDATA[".plxUtils::cdataCheck(trim($url_link))."]]></url_link>\n";
					$xml = str_replace("../../","",$xml); # corriger le problème de chemin relatif (sale mais j\'ai pas trouvé mieux :-/)
				?>';
	}

	##############################################################################
	# plxAdminEditArticle
	##############################################################################
	# Récupère le fichier image s'il y en a
	public function plxAdminEditArticle(){
		echo '<?php
				if (empty($content["date_update_old"])){
					$content["date_update_old"]=$content["date_creation_year"].$content["date_creation_month"].$content["date_creation_day"].substr(str_replace(":","",$content["date_creation_time"]),0,4);;
				}
				?>';
		
	}




	##############################################################################
	# plxMotorParseArticle
	##############################################################################
	# Gestion de l'url dans le parsing d'un article
	public function plxMotorParseArticle(){
		echo '<?php 
		if (!empty($iTags["url_link"])){
			$art["url_link"] = $values[$iTags["url_link"][0]]["value"];
		}else{
			$art["url_link"] = "";
		}

		?>';
	}



	##############################################################################
	# AdminArticleContent
	##############################################################################
	# Ajout d'un input sur la page admin pour gérer le lien associé à un article
	public function AdminArticleContent(){
		$label=$this->getLang("L_ARTICLE_URL_LINK");
		echo '
					<div class="sml-12">
						<label for="id_url_link">'.$label.':</label>
						<?php plxUtils::printInput("url_link",plxUtils::strCheck($url_link),"url","27-255",false,"full-width"); ?>
					</div>
				';
		}



	##############################################################################
	# AdminArticlePreview
	##############################################################################
	# Gestion du lien dans la prévisualisation d'un article	
	public function AdminArticlePreview(){
		echo '<?php	$art["url_link"] = plxUtils::strCheck($_POST["url_link"]);?>';
	}

	##############################################################################
	# AdminArticlePostData
	##############################################################################
	# Gestion du lien posté dans l'article et upload éventuel de l'image
	public function AdminArticlePostData(){
		echo '<?php	$url_link = plxUtils::strCheck($_POST["url_link"]);?>';
		
	}

	##############################################################################
	# 4 AdminArticleParseData
	##############################################################################
	# Ajout de la variable $url_link (édition d'un article)
	public function AdminArticleParseData(){
		echo '<?php 
			if (!isset($result["url_link"])){
				$url_link="";
			}else{
				$url_link=$result["url_link"];
			}
		?>';
	}

	##############################################################################
	# 5 AdminArticleInitData (création d'un article)
	##############################################################################
	# Ajout de la variable $url_link lors de l'initialisation
	public function AdminArticleInitData(){
		echo '<?php	$url_link = "";?>';
	}


	########################################
	# AdminProfilTop
	########################################
	# Description:
	public function AdminProfilTop(){
		$this->showBookmarkletLink();
	}

	########################################
	# showLinkedURL
	########################################
	# Affichage du lien vers l'url
	public function showLinkedURL(){
		$this->setPlxVars();
		$title = plxUtils::strCheck($this->plxShow->plxMotor->plxRecord_arts->f('title'));
		$url_link = $this->plxShow->plxMotor->plxRecord_arts->f('url_link');
		
		$cat = $this->plxShow->plxMotor->plxRecord_arts->f('categorie');

		if (empty($url_link)){
			echo '<a href="';
			$this->plxShow->urlRewrite('index.php?article'.$this->plxShow->plxMotor->plxRecord_arts->f('numero').'/'.$this->plxShow->plxMotor->plxRecord_arts->f('url'));
			echo '" title="Article" class="cat'.$cat.'">'.$title.'</a>';
		}else{
			echo '<a href="'.$url_link.'" title="'.$url_link.'" class="cat'.$cat.' weblink">'.$title.'</a>';
		}
	}

	########################################
	# plxShowLastArtListContent
	########################################
	# Retire les articles ayant un lien associé de la liste des derniers articles
	public function plxShowLastArtListContent(){
		echo '
		<?php if (!empty($art["url_link"])){
			$row =str_replace(" class=\""," class=\"weblink ",$row);
			$row = str_replace("#url_link",$art["url_link"],$row);
		} ?>
		';
	}


	########################################
	# showPermalink
	########################################
	# Affichage du lien vers l'article sous forme de permalien
	public function showPermalink(){
		$this->setPlxVars();
		$id = intval($this->plxShow->plxMotor->plxRecord_arts->f('numero'));
		$title = plxUtils::strCheck($this->plxShow->plxMotor->plxRecord_arts->f('title'));
		$url = $this->plxShow->plxMotor->plxRecord_arts->f('url');
		# On effectue l'affichage
		echo '<a href="'.$this->plxShow->plxMotor->urlRewrite('?article'.$id.'/'.$url).'" title="'.$title.'">Permalink</a>';
	}


	########################################
	# showWebLinksRSSLink
	########################################
	# Affichage du lien vers le flux rss de la catégorie weblinks
	public function showWebLinksRSSLink(){
		$this->setPlxVars();
		$catId=$this->setCatId();
		echo '<a class="RSS_feed" href="';
		$this->plxShow->urlRewrite(PLX_ROOT.'feed.php?rss/categorie'.$catId);
		echo '" title="Flux RSS de '.$this->title.'">'.$this->title.'</a>';
	}

	########################################
	# showBookmarkletLink
	########################################
	# Description:
	public function showBookmarkletLink(){
		$this->setPlxVars();
		if (empty($this->plxMotor->racine)){
			$root=$this->plxAdmin->racine;
		}else{
			$root=$this->plxMotor->racine;
		}
		echo '<style>
				#profil .WDDWebLinksBookmarklet{
				    padding:15px;
				    background:rgba(0,0,0,0.2);
				    list-style:none;
				    margin:5px;
				    display:inline-block;
				}
				#profil .WDDWebLinksBookmarklet *{
				    vertical-align:middle;
				}
				#profil .WDDWebLinksBookmarklet img{
				    width:32px;height:auto;
				}
			</style>';
			
		echo '<li class="WDDWebLinksBookmarklet"><a href="javascript:javascript:(function(){url=encodeURIComponent(location.href);title=encodeURIComponent(document.title.replace(/ String.fromCharCode(34)/g,\'__\'))||url;window.open(\''.$root.'?url=\'+url+\'&user='.$_SESSION['user'].'\'+\'&title=\' + title+\'&source=bookmarkletweblinks\',\'mybookmarklet\',\'\');})();" title="'.$this->getLang('L_DRAG_THIS_LINK').'"><img src="'.PLX_PLUGINS.'WDDWebLinks/icon.png">'.$this->getParam('linkname').'</a></li>';
	}

	########################################
	# Private methods
	########################################
	private function getTagList(){
		$tags=array();
		$GET_tags=!empty($_GET['tags'])?explode(',',strip_tags($_GET['tags'])):[];

		foreach($this->plxMotor->aTags as $article){
			$tag=array_flip(array_map('trim',explode(',',$article['tags'])));
			$tags=array_merge($tags,$tag);
		}
		ksort($tags, SORT_FLAG_CASE+ SORT_NATURAL);
		
		$taglist='';
		foreach($tags as $tag=>$osef){
			if (!empty($tag)){
				if (array_search($tag,$GET_tags)!==false){
					$checked=' checked';
				}else{
					$checked='';
				}
				$taglist.='<input type="checkbox"'.$checked.' value="'.$tag.'" id="'.$tag.'" name="tags[]"><label for="'.$tag.'">'.$tag.'</label>';
			}
		}
 		return $taglist;
 
	 	return $tags;
	}

	private function newIdArticle(){
		$aFiles=$this->plxMotor->plxGlob_arts->aFiles;
		ksort($aFiles);
		$last=intval(array_keys($aFiles)[count($aFiles)-1])+1;
		$last=sprintf("%'.04d", $last);
		return $last;			
	}	
	private function setCatId($cats=null){
		if (!$cats&&!empty($this->plxAdmin)){
			$cats=$this->plxAdmin->aCats;
		}elseif (!$cats&&!empty($this->plxMotor)){
			$cats=$this->plxMotor->aCats;
		}else{return 'houla';}

		foreach ($cats as $id => $data) {
			if (mb_strtolower($data['name'])==mb_strtolower($this->title)){
				$this->catId=$id;
				return $id;
			}
		}
		if (empty($cats2[$this->title])){
			$id++;
			$id="$id";
			$id=str_repeat('0', 3-strlen($id)).$id;
		}
		$this->catId=$id;
		return $id;
	}

	private function setPlxVars(){ # récupère les instances de travail
		$this->plxMotor=class_exists('plxMotor')?plxMotor::getInstance():false;
		$this->plxPlugins=$this->plxMotor->plxPlugins;
		$this->plxShow=class_exists('plxShow')?plxShow::getInstance():false;
		$this->plxAdmin=class_exists('plxAdmin')?plxAdmin::getInstance():false;
	}


}





/* Pense-bete:
 * Récuperer des parametres du fichier parameters.xml
 *	$this->getParam("<nom du parametre>")
 *	$this-> setParam ("param1", 12345, "numeric")
 *	$this->saveParams()
 *
 *	plxUtils::strCheck($string) : sanitize string
 *
 * 
 * Quelques constantes utiles: 
 * PLX_CORE
 * PLX_ROOT
 * PLX_CHARSET
 * PLX_CONFIG_PATH
 * PLX_PLUGINS
 * PLX_CONFIG_PATH
 * PLX_ADMIN (true si on est dans admin)
 * PLX_CHARSET
 * PLX_VERSION
 * PLX_FEED
 *
 * Appel de HOOK dans un thème
 *	eval($this->plxShow->callHook("showLinkedURL","param1"))  ou eval($this->plxShow->callHook("ThemeEndHead",array("param1","param2")))
 *	ou $retour=$this->plxShow->callHook("ThemeEndHead","param1"));
 */